//
//  SelfieInteractor.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol SelfieBusinessLogic
{
    func doInitialConfig(request: Selfie.Config.Request)
    func startRecognition(request: Selfie.Config.Request)
    func stopRecognition(request: Selfie.Config.Request)
    func doTakeSelfieAgain(request: Selfie.Config.Request)
    func setupCameraSession(request: Selfie.Camera.Session)
    func switchCamera(request: Selfie.Camera.Session)
    
    func processSmile(request : Selfie.SmileDetector.Request)
    func processBlink(request : Selfie.BlinkDetector.Request)
    
    func takePhotoFromUser(request : Selfie.Photo.Request)
}

protocol SelfieDataStore
{
  var showFrontCamera: Bool! { get set }
}

class SelfieInteractor: SelfieBusinessLogic, SelfieDataStore
{
    var showFrontCamera: Bool!
    
    
  var presenter: SelfiePresentationLogic?
  var worker: SelfieWorker?
  
  // MARK:
    func doInitialConfig(request: Selfie.Config.Request){
        worker = SelfieWorker()
        let response = worker?.initializeCameraSession(selectFrontCamera: self.showFrontCamera)
        presenter?.presentInitialConfigResult(response: response!)
    }
    
    
    func startRecognition(request: Selfie.Config.Request) {
        worker?.startRecognition(request: request)
    }
    
    func stopRecognition(request: Selfie.Config.Request) {
        worker?.stopRecognition(request: request)
    }
    
    func doTakeSelfieAgain(request: Selfie.Config.Request){
        worker?.startRecognition(request: request)
        presenter?.presentTakeSelfieAgain()
    }
    
    func setupCameraSession(request: Selfie.Camera.Session) {
        let videoOutput = worker?.setupCameraSession(camSession: request.camSession, cameraDevice: request.frontCameraDevice, captureVideoDataOutputSampleBufferDelegate: request.captureVideoDataOutputSampleBufferDelegate)
        var cameraSesion = Selfie.Camera.Session()
        cameraSesion.videoOutput = videoOutput
        presenter?.presentSetupCameraSessionResult(response: cameraSesion)
    }
    
    func switchCamera(request: Selfie.Camera.Session) {
        let response =  worker?.switchCamera(camSession: request.camSession)
        presenter?.presentSwitchedCamera(response: response!)
    }
    
    func takePhotoFromUser(request : Selfie.Photo.Request){
        let response = worker?.processBufferToPhoto(sampleBuffer: request.sampleBuffer, ciContext: request.ciContext!)
        presenter?.presentProcessBufferToPhoto(response: response!)
    }

    
    func processSmile(request : Selfie.SmileDetector.Request){
        //let response = worker?.processSmile(smile: request.smile, smilingProbability: request.smilingProbability)
        let response = worker?.processSmile(smile: request.smile, glassesTimeStamps: request.glassesTimeStamps, face: request.face!)
        presenter?.presentProcessSmileResult(response: response!)
    }
    
    
    func processBlink(request : Selfie.BlinkDetector.Request){
        //let response = worker?.processSmile(smile: request.smile, glassesTimeStamps: request.glassesTimeStamps, face: request.face!)
        let response = worker?.processBlink(blink: request.blink, glassesTimeStamps : request.glassesTimeStamps, face : request.face!)
        presenter?.presentProcessSmileResult(response: response!)
    }
}
